#include "stdafx.h"
#include <cassert>
#include <fstream>
#include <iostream>
#include <iostream>
#include <boost/smart_ptr.hpp>
#include <boost/algorithm/string.hpp>
#include "tinyxml2.h"
#include "M_monster.h"
#include "FileEncrypt.h"
std::auto_ptr<M_monster> M_monster::msSingleton(nullptr);

int M_monster::GetCount()
{
	return (int)mMapData.size();
}

const M_monsterData* M_monster::GetData(int64_t ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

boost::unordered_map<int64_t, M_monsterData>& M_monster::GetMapData()
{
	return mMapData;
}

void M_monster::Reload()
{
	mMapData.clear();
	Load();
}

void M_monster::Load(const std::string& path)
{
	std::ifstream readStream(path, std::ios::binary);
	if (!readStream.is_open())
	{
		assert(false);
		return;
	}
	readStream.seekg(0, std::ios::end);
	int fileSize = readStream.tellg();
	boost::shared_array<char> buffer(new char[fileSize+1]);
	buffer.get()[fileSize] = '\0';
	readStream.seekg(0, std::ios::beg);
	readStream.read(buffer.get(), fileSize);
	readStream.close();
	FileEncrypt::decryptBuffer( buffer, fileSize );
	tinyxml2::XMLDocument xmlDoc;
	auto result = xmlDoc.Parse(buffer.get(), fileSize);
	if (result != tinyxml2::XML_SUCCESS)
	{
		assert(false);
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		assert(false);
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_monsterData data;
		{
			int64_t temp = 0;
			const char* str = element->Attribute("ID");
			tinyxml2::XMLUtil::ToInt64(str, &temp);
			data.mID = temp;
		}
		data.mname = element->Attribute("name");
		data.mtype = element->IntAttribute("type");
		data.mmultiple = element->IntAttribute("multiple");
		data.micon = element->Attribute("icon");
		data.maspect = element->Attribute("aspect");
		data.mspeed = element->FloatAttribute("speed");
		data.msuper_speed = element->FloatAttribute("super_speed");
		data.mzoom_factor = element->FloatAttribute("zoom_factor");
		data.mexp_value = element->IntAttribute("exp_value");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		assert(mMapData.find(data.mID) == mMapData.end());
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
}

void M_monster::Load()
{
	Load("../Config/M_monster.xml");
}

M_monster* M_monster::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_monster());
	}
	return msSingleton.get();
}
